!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module FileSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!NAMELIST ファイル名を設定し, deepconv/arare の出力ファイルを
!NAMELIST から得るためのモジュール
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end
module fileset
  !== 暗黙の型宣言禁止
  implicit none

  !== save 属性
  save
                                                                 !=begin
  !== Public Data
  character(80) :: cfgfile    = "arare.conf"  !設定ファイル

  !== Public Interface
  character(80) :: RegFile            !出力 nc ファイル(物理領域)
  character(80) :: DimFile            !出力 nc ファイル(計算領域)
  character(80) :: ReStartFile        !入力用リスタートファイル
  character(80) :: NewReStartFile     !出力用リスタートファイル
                                                                 !=end
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST からファイル名に付けるタグを得て, 出力ファイル名を作成する. 
  !
  subroutine fileset_init
    !=== Dependency
    use dc_trace,      only: BeginSub, EndSub 
                                                                 !=end
    !=== 暗黙の型宣言禁止
    implicit none

    !=== Work
    character(80) :: flag
                                                                 !=begin
    !=== NAMELIST
    NAMELIST /fileset/ flag, ReStartFile
                                                                 !=end

    call BeginSub("fileset_init", &
&                 fmt="%c",       &
&                 c1="Initialize file names. ")

    open (10, FILE=cfgfile)
    read(10, NML=fileset)
    close(10)

    RegFile = "arare-"     // trim(flag) // ".nc"
    DimFile = "arare_dim-" // trim(flag) // ".nc"
    NewReStartFile = "arare-" // trim(flag) // "-restart.nc"

    !=== 確認
!    write(*,*) "cfgfile", cfgfile
!    write(*,*) ""
!    write(*,*) "RegFile", RegFile
!    write(*,*) ""
!    write(*,*) "DimFile", DimFile
!    write(*,*) ""
!    write(*,*) "ReStartFile", ReStartFile


    call EndSub("fileset_init")
    
  end subroutine fileset_init
  
end module fileset
